=== debian/changelog ===
hatari (2.0.0+dfsg-3) unstable; urgency=medium

  * Add patch 08-add-aarch64-support, fixing FTBFS on aarch64.
  * Add patch 09-do-not-bail-on-unknown-cpu, fixing FTBFS on s390x.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 15 Jan 2017 09:43:19 +0100

hatari (2.0.0+dfsg-2) unstable; urgency=medium

  * Add patch 07-add-mips-support, fixing FTBFS on mips.
    Thanks to Radovan Birdic. (Closes: #851267)

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 15 Jan 2017 01:30:03 +0100

hatari (2.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright years.
  * Build-Depend on libsdl2-dev.
  * Bump Standards-Version, no changes needed.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Tue, 10 Jan 2017 21:22:51 +0100
