=== debian/control ===
Source: hatari
Section: otherosfs
Priority: optional
Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
Build-Depends: cmake,
               debhelper (>= 9),
               dh-python,
               libpng-dev,
               libreadline-dev,
               libsdl2-dev,
               portaudio19-dev,
               python,
               zlib1g-dev
Standards-Version: 3.9.8
Homepage: http://hatari.tuxfamily.org/

Package: hatari
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Recommends: binfmt-support
Suggests: dosfstools, mtools, unzip
Description: Emulator for the Atari ST, STE, TT, and Falcon computers
 Hatari is an emulator for the Atari ST line of computers.
 .
 The Atari ST was a 16/32 bit computer system which was first released by
 Atari in 1985. Using the Motorola 68000 CPU, it was a very popular computer
 having quite a lot of CPU power at that time.
 .
 Unlike many other Atari ST emulators which try to give you a good environment
 for running GEM applications, Hatari tries to emulate the hardware of a ST as
 close as possible so that it is able to run most of the old ST games and
 demos.
