=== debian/watch ===
version=3
        opts=dversionmangle=s/\+dfsg//,uversionmangle=s/(.*)/$1+dfsg/ \
        http://download.tuxfamily.org/hatari/(\d\.\d\.\d)/hatari-(.*).tar.bz2
