## hatari 2.1.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,4 @@
-
-cmake_minimum_required(VERSION 2.6 FATAL_ERROR)
-
-if(POLICY CMP0026)
-	# Should be removed if cmake_minimum_required >= 2.8.8
-	cmake_policy(SET CMP0026 OLD)
-endif(POLICY CMP0026)
+cmake_minimum_required(VERSION 2.8.8 FATAL_ERROR)
 
 project(Hatari C)
 
@@ -70,7 +64,7 @@
 
 if(APPLE)
 	set(ENABLE_OSX_BUNDLE 1
-	    CACHE BOOL "Built Hatari as Mac OS X application bundle")
+	    CACHE BOOL "Built Hatari as macOS application bundle")
 	# set(CMAKE_OSX_ARCHITECTURES "i386" CACHE STRING "Target architectures" FORCE)
 	# set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.6.sdk" CACHE STRING "10.6 SDK" FORCE)
 	# set(CMAKE_OSX_DEPLOYMENT_TARGET "10.5" CACHE STRING "Target Min 10.5" FORCE)
@@ -78,7 +72,7 @@
 	set_source_files_properties(${FRAMEWORKS} PROPERTIES MACOSX_PACKAGE_LOCATION Frameworks)
 else()
 	set(ENABLE_OSX_BUNDLE 0
-	    CACHE BOOL "Built Hatari as Mac OS X application bundle")
+	    CACHE BOOL "Built Hatari as macOS application bundle")
 endif(APPLE)
 
 # ####################
@@ -131,6 +125,11 @@
 if(PORTAUDIO_FOUND)
 	set(HAVE_PORTAUDIO 1)
 endif(PORTAUDIO_FOUND)
+
+find_package(PortMidi)
+if(PORTMIDI_FOUND)
+	set(HAVE_PORTMIDI 1)
+endif(PORTMIDI_FOUND)
 
 find_package(CapsImage)
 if(CAPSIMAGE_FOUND)
@@ -224,14 +223,14 @@
 endif(ENABLE_MUDFLAP)
 
 # Warning flags:
-if(CMAKE_COMPILER_IS_GNUCC)
+if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-qual -Wbad-function-cast -Wpointer-arith")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes -Wstrict-prototypes")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wwrite-strings -Wsign-compare")
 	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wextra -Wno-unused-parameter -Wno-empty-body")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat-security")
 	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow -D_FORTIFY_SOURCE=2 -Werror")
-endif(CMAKE_COMPILER_IS_GNUCC)
+endif()
 
 # Building Hatari w/o optimization is no fun...
 IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
@@ -358,6 +357,12 @@
   message( "  - portaudio :\tnot found, install it to enable the Falcon microphone input" )
 endif(PORTAUDIO_FOUND)
 
+if(PORTMIDI_FOUND)
+  message( "  - portmidi :\tfound, required for (non-Linux) MIDI support" )
+else()
+  message( "  - portmidi :\tnot found, install it for MIDI support on Windows / OSX" )
+endif(PORTMIDI_FOUND)
+
 if(CAPSIMAGE_FOUND)
   message( "  - capsimage :\tv${CAPSIMAGE_VERSION} found, allow to use .IPF, .RAW and .CTR disk images" )
 else()
