=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,23 +9,23 @@
 	paths.c  psg.c printer.c resolution.c rs232.c reset.c rtc.c
 	scandir.c stMemory.c screen.c screenConvert.c screenSnapShot.c
 	shortcut.c sound.c spec512.c statusbar.c str.c tos.c utils.c
-	vdi.c video.c wavFormat.c xbios.c ymFormat.c)
+	vdi.c inffile.c video.c wavFormat.c xbios.c ymFormat.c)
 
 # Disk image code is shared with the hmsa tool, so we put it into a library:
 add_library(Floppy createBlankImage.c dim.c msa.c st.c zip.c)
 
-# When building for OSX, define specific sources for gui and ressources
+# When building for macOS, define specific sources for gui and ressources
 if(ENABLE_OSX_BUNDLE)
 	set(GUIOSX_SOURCES
 	    gui-osx/AlertHooks.m gui-osx/PrefsController.m gui-osx/Shared.m
 	    gui-osx/CreateFloppyController.m gui-osx/SDLMain.m)
 	set_source_files_properties(${GUIOSX_SOURCES} PROPERTIES LANGUAGE C)
 	set(GUIOSX_RSRCS
-	    gui-osx/Hatari.icns gui-osx/en.lproj gui-osx/fr.lproj)
+	    gui-osx/Hatari.icns gui-osx/stdisk.png gui-osx/en.lproj gui-osx/fr.lproj)
 	set(GUIOSX_DOCS
 	    ${CMAKE_SOURCE_DIR}/doc/manual.html ${CMAKE_SOURCE_DIR}/doc/images
-	    ${CMAKE_SOURCE_DIR}/doc/compatibility.html)
-	# these are the OS X Interface Builder Files
+	    ${CMAKE_SOURCE_DIR}/doc/compatibility.html ${CMAKE_SOURCE_DIR}/doc/toc.js )
+	# these are the macOS Interface Builder Files
 	set (HATARI_XIBS en.lproj/SDLMain fr.lproj/SDLMain)
 endif(ENABLE_OSX_BUNDLE)
 
@@ -43,8 +43,8 @@
 	set(CPUDIR uae-cpu)
 endif(ENABLE_WINUAE_CPU)
 
-include_directories(${CMAKE_BINARY_DIR} ${SDL_INCLUDE_DIR} ${CPUDIR}
-		    includes debug falcon)
+include_directories(includes debug falcon
+		    ${CMAKE_BINARY_DIR} ${SDL_INCLUDE_DIR} ${CPUDIR})
 
 if(ZLIB_FOUND)
 	include_directories(${ZLIB_INCLUDE_DIR})
@@ -70,7 +70,7 @@
 add_subdirectory(gui-sdl)
 add_subdirectory(${CPUDIR})
 
-# When building for OSX, add specific sources
+# When building for macOS, add specific sources
 if(ENABLE_OSX_BUNDLE)
 	#find_library(SDL_FRAMEWORK SDL ${ADD_FRAMEWOK_PATH})
 	set(ADDITIONAL_INCLUDES ${FRAMEWORKS})
@@ -91,18 +91,18 @@
 			COMMAND mkdir -p ${BUNDLE_CONTENTS}/MacOS
 			COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${MACOSX_BUNDLE_ICON_FILE}
 				   ${BUNDLE_CONTENTS}/Resources/${MACOSX_BUNDLE_ICON_FILE}
-			# Copy Localized .nib to Bundle
+			# Copy Localized .nib and help to Bundle
 			COMMAND cp -R ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/*.lproj ${BUNDLE_CONTENTS}/Resources/
-			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/en.lproj/HatariHelp
-			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/en.lproj/HatariHelp/
-			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp
-			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp/
+			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/HatariHelp
+			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/HatariHelp/
+			#COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp
+			#COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp/
 	)
 	add_dependencies(hatari osx_bundle_dirs)
 	set_source_files_properties(${GUIOSX_RSRCS} PROPERTIES
 				    MACOSX_PACKAGE_LOCATION Resources)
 	set_source_files_properties(${GUIOSX_DOCS} PROPERTIES
-				    MACOSX_PACKAGE_LOCATION Resources/en.lproj/HatariHelp)
+				    MACOSX_PACKAGE_LOCATION Resources/HatariHelp)
 
 	#find ibtool
 	find_program(IBTOOL ibtool HINTS "/usr/bin" "${OSX_DEVELOPER_ROOT}/usr/bin")
@@ -116,6 +116,7 @@
 		add_custom_command (TARGET hatari POST_BUILD
 			COMMAND ${IBTOOL} --errors --warnings --notices --output-format human-readable-text
 				--compile ${BUNDLE_CONTENTS}/Resources/${xib}.nib ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${xib}.xib
+			COMMAND rm ${BUNDLE_CONTENTS}/Resources/${xib}.xib
 			COMMENT "Compiling ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${xib}.xib")
 	endforeach()
 
@@ -165,6 +166,10 @@
 	target_link_libraries(hatari ${PORTAUDIO_LIBRARY})
 endif(PORTAUDIO_FOUND)
 
+if(PORTMIDI_FOUND)
+	target_link_libraries(hatari ${PORTMIDI_LIBRARY})
+endif(PORTMIDI_FOUND)
+
 if(CAPSIMAGE_FOUND)
 	target_link_libraries(hatari ${CAPSIMAGE_LIBRARY})
 endif(CAPSIMAGE_FOUND)
