=== src/gui-sdl/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 
 include_directories(. ../.. ../debug ../includes ${SDL_INCLUDE_DIR}) 
 
-if(CMAKE_COMPILER_IS_GNUCC)
+if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-write-strings")
-endif(CMAKE_COMPILER_IS_GNUCC)
+endif()
 
 add_library(GuiSdl
 	dlgAbout.c dlgAlert.c dlgCpu.c dlgDevice.c dlgFileSelect.c dlgFloppy.c
