=== debian/changelog ===
hatari (2.1.0+dfsg-1) unstable; urgency=medium

  * Drop non-free disk image from upstream tarball.
  * Import upstream version 2.1.0.
  * Drop patches included upstream.
  * Drop patches taken from upstream VCS.
  * Add 06-fix-typo-in-manpage, fixing typo in manpage.
  * Update debian/copyright, authors and years.
  * Bump Standards-Version to 4.1.3, no changes needed.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 25 Feb 2018 10:17:09 +0100

hatari (2.0.0+dfsg-4) unstable; urgency=medium

  * Add missing dependency on python-gtk2. (Closes: 881961)
  * Fix upstream bugs with patches from upstream vcs (Closes: 881964)
    - 10-fix-pythonui-new-config-file-locations
    - 11-fix-pythonui-options
    - 12-fix-sdl2-window-embedding
  * Fix watch file to not report false positives.
  * Drop redundant winuae cpu variant, it is now the default.
  * Bump debhelper compatibility level to 10.
  * Use https in copyright format URL.
  * Simplify debian/copyright, group GPL-2+ copyrights together.
  * Use https URL in debian/watch.
  * Use hardening=+all to get bindnow linker flag.
  * Bump standards-version to 4.1.1, no changes needed.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sat, 18 Nov 2017 18:02:20 +0100
