=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
 Build-Depends: cmake,
-               debhelper (>= 9),
+               debhelper (>= 10),
                dh-python,
                libpng-dev,
                libreadline-dev,
@@ -11,12 +11,12 @@
                portaudio19-dev,
                python,
                zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Homepage: http://hatari.tuxfamily.org/
 
 Package: hatari
 Architecture: any
-Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}, python-gtk2
 Recommends: binfmt-support
 Suggests: dosfstools, mtools, unzip
 Description: Emulator for the Atari ST, STE, TT, and Falcon computers
